SystemOrganization addCategory: #'Rizel-Test'!

TestCase subclass: #RizelTest
	instanceVariableNames: ''
	classVariableNames: 'mondrian1DResult mondrian2DResult'
	poolDictionaries: ''
	category: 'Rizel-Test'!

!RizelTest class methodsFor: 'as yet unclassified' stamp: ''!
mondrian1DResult
	^ mondrian1DResult! !

!RizelTest class methodsFor: 'as yet unclassified' stamp: ''!
mondrian1DResult: t1 
	mondrian1DResult := t1! !

!RizelTest class methodsFor: 'as yet unclassified' stamp: ''!
mondrian2DResult
	^ mondrian2DResult! !

!RizelTest class methodsFor: 'as yet unclassified' stamp: ''!
mondrian2DResult: t1 
	mondrian2DResult := t1! !

!RizelTest class methodsFor: 'as yet unclassified' stamp: ''!
selectFrom: t1 multipleOf: t2 
	| t3 t4 |
	t4 := 1.
	t3 := OrderedCollection new.
	t1
		do: [:t6 | 
			t4 \\ t2 = 0
				ifTrue: [t3 add: t6].
			t4 := t4 + 1].
	^ t3! !

!RizelTest methodsFor: 'as yet unclassified' stamp: ''!
selectFrom: t1 multipleOf: t2 
	| t3 t4 |
	t4 := 1.
	t3 := OrderedCollection new.
	t1
		do: [:t6 | 
			t4 \\ t2 = 0
				ifTrue: [t3 add: t6].
			t4 := t4 + 1].
	^ t3! !

!RizelTest methodsFor: 'as yet unclassified' stamp: ''!
test1D
	| t1 t2 t3 t4 t5 t6 |
	t1 := Rizel new.
	t3 := (ConfigurationOfMondrian project versions last: 50) reverse.
	t3 := self selectFrom: t3 multipleOf: 10.
	t1
		define: #input
		named: #version
		with: t3.
	self assert: t1 inputs size = 1.
	RizelTest mondrian1DResult
		ifNil: [RizelTest
				mondrian1DResult: (t1
						execute: [:t7 | 
							t7 load.
							t1
								profile: [| t8 |
									t8 := MOViewRenderer new.
									t8 nodes: Collection withAllSubclasses.
									t8 edgesFrom: #superclass.
									t8 treeLayout.
									t8 root applyLayout]
								inPackagesMatching: 'Mondrian-*'])].
	t2 := RizelTest mondrian1DResult.
	t2 values
		do: [:t7 | self assert: t7 notNil].
	t4 := (t1 inputsOf: #version)
				collect: [:t7 | t2 of: t7].
	t5 := t4
				minValue: [:t7 | t7 numberOfEmittedCalls // 100].
	t6 := t4
				maxValue: [:t7 | t7 numberOfEmittedCalls // 100].
	t1 visualize v1D values: t4;
		
		yAxis: [:t7 | t7
				ifNil: [0]
				ifNotNil: [t7 numberOfEmittedCalls // 100]];
		 factor: 5;
		
		max: (t2
				maxValue: [:t7 | t7 numberOfEmittedCalls // 100]);
		
		min: (t2
				minValue: [:t7 | t7 numberOfEmittedCalls // 100]).
	t1 display! !

!RizelTest methodsFor: 'as yet unclassified' stamp: ''!
test2D
	| rizel result versions benchmarks |
	rizel := Rizel new.
	versions := (ConfigurationOfMondrian project versions last: 100) reverse.
	versions := self selectFrom: versions multipleOf: 10.
	benchmarks := #(#manyNodes #subviews #openSimpleGraph ).
	rizel
		define: #input
		named: #version
		with: versions.
	rizel
		define: #input
		named: #benchmark
		with: benchmarks.
	RizelTest mondrian2DResult
		ifNil: [RizelTest
				mondrian2DResult: (rizel
						execute: [:version :method | 
							version load.
							rizel
								profile: [RizelTest new perform: method]
								inPackagesMatching: 'Mondrian-*'])].
	result := RizelTest mondrian2DResult.
	rizel visualize v2D xValues: (rizel inputsOf: #version) asSortedCollection;
		
		yValues: (rizel inputsOf: #benchmark);
		
		value: [:x :y | [(result of: (OrderedCollection new add: x;
					 add: y;
					 yourself)) numberOfEmittedCalls // 100]
				on: Error
				do: [0]];
		
		xLabel: [:x | x versionNumber].
	rizel display! !

!RizelTest methodsFor: 'as yet unclassified' stamp: ''!
test2DPopup
	| t1 t2 t3 t4 |
	t1 := Rizel new.
	t3 := (ConfigurationOfMondrian project versions last: 100) reverse.
	t3 := self selectFrom: t3 multipleOf: 10.
	t4 := #(#edges #manyNodes #subviews2 #form1 #openSimpleGraph #reportPackageBlueprintLikeProfiling ).
	t1
		define: #input
		named: #version
		with: t3.
	t1
		define: #input
		named: #benchmark
		with: t4.
	RizelTest mondrian2DResult
		ifNil: [RizelTest
				mondrian2DResult: (t1
						execute: [:t5 :t6 | 
							t5 load.
							t1
								profile: [MOBenchmarks new perform: t6]
								inPackagesMatching: 'Mondrian-*'])].
	t2 := RizelTest mondrian2DResult.
	t1 visualize v2D xValues: (t1 inputsOf: #version) asSortedCollection;
		
		yValues: (t1 inputsOf: #benchmark);
		
		value: [:t5 :t6 | [(t2 of: (OrderedCollection new add: t5;
					 add: t6;
					 yourself)) numberOfEmittedCalls // 100]
				on: Error
				do: [0]];
		
		xLabel: [:t5 | t5 versionNumber];
		
		xPopupView: [:t5 :t6 :t7 | 
			| t8 t10 |
			t7 shape rectangle.
			t7
				node: t5
				forIt: [t8 := RzVisualizer1D new.
					t10 := t6
								collect: [:t11 | t2 of: (OrderedCollection new add: t11;
											 add: t5;
											 yourself)].
					t8 values: t10;
						
						yAxis: [:t11 | t11
								ifNil: [0]
								ifNotNil: [t11 numberOfEmittedCalls // 100]];
						 xAxis: t6;
						
						label: [:t11 | t11 versionNumber].
					t8 visualizeOn: t7]].
	t1 display! !

!RizelTest methodsFor: 'as yet unclassified' stamp: ''!
testDiff
	| t1 t2 t3 |
	t3 := RizelTest mondrian1DResult values.
	t1 := t3 first.
	t2 := t3 last.
	RzBrowserDiff
		openOn: (Rizel new merge: t1 with: t2)! !

!RizelTest methodsFor: 'as yet unclassified' stamp: ''!
testDiffView
	| t1 t2 t3 t4 t5 |
	t5 := (ConfigurationOfMondrian project versions last: 100) reverse.
	t5 := (self selectFrom: t5 multipleOf: 10) asSortedCollection.
	t1 := RizelTest mondrian2DResult of: (OrderedCollection new
					add: (t5 at: 4);
					 add: #subviews;
					 yourself).
	t2 := RizelTest mondrian2DResult of: (OrderedCollection new
					add: (t5 at: 5);
					 add: #subviews;
					 yourself).
	t4 := RzVisualizerDiff
				on: (Rizel new merge: t1 with: t2).
	t4 visualize! !

TestCase subclass: #RizelVisualizationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Test'!

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test1D
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 3 4 ).
	t1 := MResultSet new.
	t1 key: #(1 ) value: 10.
	t1 key: #(2 ) value: 20.
	t1 key: #(3 ) value: 15.
	t1 key: #(4 ) value: 30.
	t3 := (t2 inputsOf: #x)
				collect: [:t4 | t1 of: t4].
	t2 visualize v1D values: t3;
		
		yAxis: [:t4 | t4].
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test1Dcolor
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 3 4 ).
	t1 := MResultSet new.
	t1 key: #(1 ) value: 10.
	t1 key: #(2 ) value: 20.
	t1 key: #(3 ) value: 15.
	t1 key: #(4 ) value: 30.
	t3 := (t2 inputsOf: #x)
				collect: [:t4 | t1 of: t4].
	t2 visualize v1D values: t3;
		
		yAxis: [:t4 | t4];
		
		label: [:t4 | 1].
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test1Dfactor
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 3 4 ).
	t1 := MResultSet new.
	t1 key: #(1 ) value: 10.
	t1 key: #(2 ) value: 20.
	t1 key: #(3 ) value: 15.
	t1 key: #(4 ) value: 30.
	t3 := (t2 inputsOf: #x)
				collect: [:t4 | t1 of: t4].
	t2 visualize v1D values: t3;
		
		yAxis: [:t4 | t4].
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test1Dmultiline
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 3 4 ).
	t1 := MResultSet new.
	t1 key: #(1 ) value: 10.
	t1 key: #(2 ) value: 20.
	t1 key: #(3 ) value: 15.
	t1 key: #(4 ) value: 30.
	t3 := (t2 inputsOf: #x)
				collect: [:t4 | t1 of: t4].
	t2 visualize v1D values: t3;
		
		yAxis: [:t4 | t4];
		
		yAxis: [:t4 | t4 - 10].
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test1Dv2
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 3 4 ).
	t1 := MResultSet new.
	t1 key: #(1 ) value: 10.
	t1 key: #(2 ) value: 20.
	t1 key: #(3 ) value: 15.
	t1 key: #(4 ) value: 30.
	t3 := (t2 inputsOf: #x)
				collect: [:t4 | t1 of: t4].
	t2 visualize v1D values: t3;
		
		yAxis: [:t4 | t4].
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test2D
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 ).
	t2
		define: #input
		named: #y
		with: #(1 2 ).
	t1 := MResultSet new.
	t1 key: #(1 1 ) value: 10.
	t1 key: #(1 2 ) value: 20.
	t1 key: #(2 1 ) value: 15.
	t1 key: #(2 2 ) value: 30.
	t2 visualize v2D
		xValues: (t2 inputsOf: #x);
		
		yValues: (t2 inputsOf: #y);
		
		value: [:t4 :t5 | t1 of: (OrderedCollection new add: t4;
					 add: t5;
					 yourself)];
		 factor: 10.
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test2Dcolor
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 ).
	t2
		define: #input
		named: #y
		with: #(1 2 ).
	t1 := MResultSet new.
	t1 key: #(1 1 ) value: 10.
	t1 key: #(1 2 ) value: 20.
	t1 key: #(2 1 ) value: 15.
	t1 key: #(2 2 ) value: 30.
	t2 visualize v2D
		xValues: (t2 inputsOf: #x);
		
		yValues: (t2 inputsOf: #y);
		
		value: [:t4 :t5 | t1 of: (OrderedCollection new add: t4;
					 add: t5;
					 yourself)].
	t2 display! !

!RizelVisualizationTest methodsFor: 'as yet unclassified' stamp: ''!
test2Dfactor
	| t1 t2 t3 |
	t2 := Rizel new.
	t2
		define: #input
		named: #x
		with: #(1 2 ).
	t2
		define: #input
		named: #y
		with: #(1 2 ).
	t1 := MResultSet new.
	t1 key: #(1 1 ) value: 10.
	t1 key: #(1 2 ) value: 20.
	t1 key: #(2 1 ) value: 15.
	t1 key: #(2 2 ) value: 30.
	t2 visualize v2D
		xValues: (t2 inputsOf: #x);
		
		yValues: (t2 inputsOf: #y);
		
		value: [:t4 :t5 | t1 of: (OrderedCollection new add: t4;
					 add: t5;
					 yourself)];
		 factor: 50.
	t2 display! !
